#ifndef CHIP_RST_H
#define CHIP_RST_H

#include "lcspec.h"
#include <stdint.h>
#include "chip_devtype_spec_features.h"


#if CHIP_DEV_SUPPORT_CORE_CM4
#define CHIP_RST_RST_FLAGS_ALL_CPU        (CHIP_REGFLD_RCC_RSR_C1RSTF | CHIP_REGFLD_RCC_RSR_C2RSTF)
#else
#define CHIP_RST_RST_FLAGS_ALL_CPU        (CHIP_REGFLD_RCC_RSR_C1RSTF)
#endif


/*--- комбинации устанавливаемых флагов сброса для типичных причин сброса ----*/
/* Power-on reset (pwr_por_rst) */
#define CHIP_RST_SRCID_FLAGS_POR            (CHIP_REGFLD_RCC_RSR_D1RSTF \
                                                | CHIP_REGFLD_RCC_RSR_D2RSTF \
                                                | CHIP_REGFLD_RCC_RSR_BORRSTF \
                                                | CHIP_REGFLD_RCC_RSR_PINRSTF \
                                                | CHIP_REGFLD_RCC_RSR_PORRSTF \
                                                | CHIP_RST_RST_FLAGS_ALL_CPU)
/* Pin reset (NRST) */
#define CHIP_RST_SRCID_FLAGS_PIN            (CHIP_REGFLD_RCC_RSR_PINRSTF | CHIP_RST_RST_FLAGS_ALL_CPU)
/* Brownout reset (pwr_bor_rst) */
#define CHIP_RST_SRCID_FLAGS_BOR            (CHIP_REGFLD_RCC_RSR_BORRSTF | CHIP_REGFLD_RCC_RSR_PINRSTF | CHIP_RST_RST_FLAGS_ALL_CPU)
/* System reset generated by CPU1 (STF1RESET) */
#define CHIP_RST_SRCID_FLAGS_CPU1_SYS       (CHIP_REGFLD_RCC_RSR_PINRSTF | CHIP_REGFLD_RCC_RSR_SFT1RSTF | CHIP_REGFLD_RCC_RSR_C1RSTF)
/* WWDG1 reset (wwdg1_out_rst) */
#define CHIP_RST_SRCID_FLAGS_WWDG1          (CHIP_REGFLD_RCC_RSR_PINRSTF | CHIP_REGFLD_RCC_RSR_WWDG1RSTF | CHIP_REGFLD_RCC_RSR_C1RSTF) )
/* IWDG1 reset (iwdg1_out_rst) */
#define CHIP_RST_SRCID_FLAGS_IWDG1          (CHIP_REGFLD_RCC_RSR_PINRSTF | CHIP_REGFLD_RCC_RSR_IWDG1RSTF | CHIP_REGFLD_RCC_RSR_C1RSTF) )
/* D1 erroneously enters DStandby mode or CPU1 erroneously enters CStop mode */
#define CHIP_RST_SRCID_FLAGS_D1_CPU1_ERR    (CHIP_REGFLD_RCC_RSR_PINRSTF | CHIP_REGFLD_RCC_RSR_LPWR1RSTF)
#if CHIP_DEV_SUPPORT_CORE_CM4
/* System reset generated by CPU2 (STF2RESET) */
#define CHIP_RST_SRCID_FLAGS_CPU2_SYS       (CHIP_REGFLD_RCC_RSR_PINRSTF | CHIP_REGFLD_RCC_RSR_SFT2RSTF | CHIP_REGFLD_RCC_RSR_C2RSTF)
/* WWDG2 reset (wwdg2_out_rst) */
#define CHIP_RST_SRCID_FLAGS_WWDG2          (CHIP_REGFLD_RCC_RSR_PINRSTF | CHIP_REGFLD_RCC_RSR_WWDG2RSTF | CHIP_REGFLD_RCC_RSR_C2RSTF)
 /* IWDG2 reset (iwdg2_out_rst) */
#define CHIP_RST_SRCID_FLAGS_IWDG2          (CHIP_REGFLD_RCC_RSR_PINRSTF | CHIP_REGFLD_RCC_RSR_IWDG2RSTF | CHIP_REGFLD_RCC_RSR_C2RSTF)
/* D2 erroneously enters DStandby mode or CPU2 erroneously enters CStop mode */
#define CHIP_RST_SRCID_FLAGS_D2_CPU2_ERR    (CHIP_REGFLD_RCC_RSR_PINRSTF | CHIP_REGFLD_RCC_RSR_LPWR2RSTF)
#endif
#define CHIP_RST_SRCID_FLAGS_D1_STBY_EXIT   (CHIP_REGFLD_RCC_RSR_D1RSTF) /* D1 exits DStandby mode */
#define CHIP_RST_SRCID_FLAGS_D2_STBY_EXIT   (CHIP_REGFLD_RCC_RSR_D2RSTF) /* D2 exits DStandby mode */



static LINLINE void chip_rst_flags_clr(void) {
    CHIP_REGS_RCC->RSR |= CHIP_REGFLD_RCC_RSR_RMVF;
    chip_dmb();
    CHIP_REGS_RCC->RSR &= ~CHIP_REGFLD_RCC_RSR_RMVF;
}


static LINLINE uint32_t chip_rst_flags(void) {
    return CHIP_REGS_RCC->RSR;
}

#endif // CHIP_RST_H
